#region CVS Version Header
/*
 * $Id: ThreadedListViewEventArgs.cs,v 1.3 2005/01/22 11:20:41 t_rendelmann Exp $
 * Last modified by $Author: t_rendelmann $
 * Last modified at $Date: 2005/01/22 11:20:41 $
 * $Revision: 1.3 $
 */
#endregion

using System;
using System.ComponentModel;

namespace System.Windows.Forms.ThListView
{
	/// <summary>
	/// Summary description for ThreadCancelEventArgs.
	/// </summary>
	public class ThreadCancelEventArgs: CancelEventArgs
	{
		private ThreadedListViewItem _tlv = null;

		public ThreadCancelEventArgs(ThreadedListViewItem tlv, bool cancel): base(cancel){
			this._tlv = tlv;
		}
		public ThreadedListViewItem Item {
			get { return _tlv; }
		}
	}

	/// <summary>
	/// Summary description for ThreadEventArgs.
	/// </summary>
	public class ThreadEventArgs: EventArgs {
		private ThreadedListViewItem _tlv = null;
		private ThreadedListViewItem[] _childItems = null;

		public ThreadEventArgs(ThreadedListViewItem tlv): base() {
			this._tlv = tlv;
		}
		public ThreadedListViewItem Item {
			get { return _tlv; }
		}
		public ThreadedListViewItem[] ChildItems {
			get { return _childItems; }
			set { _childItems = value;}
		}
	}

	/// <summary>
	/// Summary description for ListLayoutEventArgs.
	/// </summary>
	public class ListLayoutEventArgs: EventArgs {
		private IListViewLayout _layout = null;

		public ListLayoutEventArgs(IListViewLayout layout): base(){
			this._layout = layout;
		}
		public IListViewLayout Layout {
			get { return _layout; }
		}
		public string LayoutXML {
			get { 
				if (_layout != null)
					return System.Windows.Forms.ThListView.ListViewLayout.SaveAsXML((System.Windows.Forms.ThListView.ListViewLayout)_layout); 
				return null;
			}
		}
	}

	/// <summary>
	/// Summary description for ListLayoutCancelEventArgs.
	/// </summary>
	public class ListLayoutCancelEventArgs: CancelEventArgs {
		private IListViewLayout _layout = null;

		public ListLayoutCancelEventArgs(IListViewLayout newLayout, bool cancel): base(cancel){
			this._layout = newLayout;
		}
		public IListViewLayout NewLayout {
			get { return _layout; }
		}
	}
}
