#region CVS Version Header
/*
 * $Id: HttpRequestFileThreadHandler.cs,v 1.6 2004/11/01 10:15:55 t_rendelmann Exp $
 * Last modified by $Author: t_rendelmann $
 * Last modified at $Date: 2004/11/01 10:15:55 $
 * $Revision: 1.6 $
 */
#endregion

using System;
using System.Net;
using System.IO;
using System.Threading;
using System.Collections;
using System.Collections.Specialized;
using System.Windows.Forms;

using NewsComponents.Feed;
using NewsComponents.Net;
using RssBandit.WinGui.Utility;

namespace RssBandit.WinGui
{
	/// <summary>
	/// Summary description for HttpRequestFileThreadHandler.
	/// </summary>
	public class HttpRequestFileThreadHandler
	{
		private AutoResetEvent workDone = new AutoResetEvent(false);
		private string requestUrl = String.Empty;
		private IWebProxy proxy = null;
		private Stream responseStream = null;
		private bool operationSucceeds = false;
		private Exception operationException = null;

		
		private HttpRequestFileThreadHandler() {;}
		public HttpRequestFileThreadHandler(string requestUrl, IWebProxy proxy) {
			this.requestUrl = requestUrl;
			this.proxy = proxy;
		}

		public string Url {
			get {	return this.requestUrl;	}
			set {	this.requestUrl = value;	}
		}

		public IWebProxy Proxy {
			get {	return this.proxy;	}
			set {	this.proxy = value;	}
		}

		public Stream ResponseStream {
			get {	return responseStream;	}
		}

		public bool OperationSucceeds {
			get {	return this.operationSucceeds;	}
		}

		public Exception OperationException {
			get {	return this.operationException;	}
		}

		public AutoResetEvent WorkDone {
			get {	return workDone;	}
		}

		public void Run() {

			this.operationSucceeds = false;
			this.responseStream = null;
			
			try {
				this.responseStream = AsyncWebRequest.GetSyncResponseStream(
					this.requestUrl, null, RssBanditApplication.UserAgent, this.Proxy); 							
				operationSucceeds = (this.responseStream != null);
				return;
			} catch (Exception e) {	// fatal errors
				this.operationException = e;
			} finally {
				workDone.Set();
			}
		}
		
	}
}
