#region CVS Version Header
/*
 * $Id: PrefetchFeedThreadHandler.cs,v 1.9 2004/10/15 15:24:53 t_rendelmann Exp $
 * Last modified by $Author: t_rendelmann $
 * Last modified at $Date: 2004/10/15 15:24:53 $
 * $Revision: 1.9 $
 */
#endregion

using System;
using System.Net;
using System.Xml;
using System.Threading;
using System.Collections;
using System.Collections.Specialized;
using System.Windows.Forms;

using NewsComponents;
using NewsComponents.Feed;
using RssBandit.WinGui.Utility;

namespace RssBandit.WinGui
{
	/// <summary>
	/// Thread handler for Prefetching a Feed to discover some properties
	/// without subscribing.
	/// </summary>
	public class PrefetchFeedThreadHandler {
		private AutoResetEvent workDone = new AutoResetEvent(false);
		private string feedUrl = String.Empty;
		private feedsFeed discoveredFeed = null;
		private FeedDetails feedInfo = null;
		private NewsHandler feedHandler; 
		private ICredentials credentials = null;
		
		private PrefetchFeedThreadHandler() {;}
		public PrefetchFeedThreadHandler(string feedUrl, NewsHandler handler) {
			this.feedUrl = feedUrl;
			this.feedHandler = handler; 
		}
	
		public Exception ExceptionCaused; 

		public string FeedUrl {
			get {	return this.feedUrl;	}
			set {	this.feedUrl = value;	}
		}

		public feedsFeed DiscoveredFeed {
			get {	return discoveredFeed;	}
		}

		public FeedDetails DiscoveredDetails {
			get {	return feedInfo;	}
		}

		public ICredentials Credentials {
			get {	return this.credentials;	}
			set {	this.credentials = value;	}
		}

		public AutoResetEvent WorkDone {
			get {	return workDone;	}
		}

		public void Run() {
			
			discoveredFeed = new feedsFeed();
			this.ExceptionCaused = null;

			try {
				
				feedInfo = feedHandler.GetFeedInfo(this.feedUrl, this.credentials);

			} catch (Exception e) {	// fatal errors
				this.ExceptionCaused = e;
				MessageBox.Show(
					Resource.Manager.FormatMessage("RES_WebExceptionOnUrlAccess", this.feedUrl, e.Message), 
					Resource.Manager["RES_GUIErrorMessageBoxCaption"], MessageBoxButtons.OK,MessageBoxIcon.Error);
			} finally {
				workDone.Set();
			}
		}
	
	}
}
